<?php
class ControllerExtensionModuleRouteeLog extends Controller {
	/**
     * @var array
     */
	private $error = array();

	/**
     * @return void
     */
	public function index() {
		$this->load->language('extension/module/routee/log');

		$this->document->setTitle($this->language->get('heading_title'));

        $array = array(
            'success',
            'warning'
        );
        foreach ($array as $value) {
            $data[$value] = $this->error[$value] ?? '';

            if (isset($this->session->data[$value])) {
                $data[$value] = $this->session->data[$value];
                unset($this->session->data[$value]);
            } else {
                $data[$value] = '';
            }
        }
		
		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/log', 'user_token=' . $this->session->data['user_token'], true)
		);
		
		$data['download'] = $this->url->link('extension/module/routee/log/download', 'user_token=' . $this->session->data['user_token'], true);
		$data['clear'] = $this->url->link('extension/module/routee/log/clear', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['log'] = '';

		$file = DIR_LOGS . 'routee.log';

		if (file_exists($file)) {
			$size = filesize($file);

			if ($size >= 5242880) {
				$suffix = array(
					'B',
					'KB',
					'MB',
					'GB',
					'TB',
					'PB',
					'EB',
					'ZB',
					'YB'
				);

				$i = 0;

				while (($size / 1024) > 1) {
					$size = $size / 1024;
					$i++;
				}
			} else {
				$data['log'] = file_get_contents($file, FILE_USE_INCLUDE_PATH, null);
			}
		}
		
		$data['user_token'] = $this->session->data['user_token'];
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/log', $data));
	}
	
	/**
     * @return void
     */
	public function download() {
		$this->load->language('extension/module/routee/log');

		$file = DIR_LOGS . 'routee.log';

		if (file_exists($file) && filesize($file) > 0) {
			$this->response->addheader('Pragma: public');
			$this->response->addheader('Expires: 0');
			$this->response->addheader('Content-Description: File Transfer');
			$this->response->addheader('Content-Type: application/octet-stream');
			$this->response->addheader('Content-Disposition: attachment; filename="' . $this->config->get('config_name') . '_' . date('Y-m-d_H-i-s', time()) . '_error.log"');
			$this->response->addheader('Content-Transfer-Encoding: binary');

			$this->response->setOutput(file_get_contents($file, FILE_USE_INCLUDE_PATH, null));
		} else {
			$this->response->redirect($this->url->link('extension/module/routee/log', 'user_token=' . $this->session->data['user_token'], true));
		}
	}
	
	/**
     * @return void
     */
	public function clear() {
		$this->load->language('extension/module/routee/log');

		if (!$this->user->hasPermission('modify', 'extension/module/routee/log')) {
			$this->session->data['error'] = $this->language->get('error_permission');
		} else {
			$file = DIR_LOGS . 'routee.log';

			$handle = fopen($file, 'w+');

			fclose($handle);

			$this->session->data['success'] = $this->language->get('text_success');
		}

		$this->response->redirect($this->url->link('extension/module/routee/log', 'user_token=' . $this->session->data['user_token'], true));
	}
}