<?php
class ControllerExtensionModuleRouteeMassExport extends Controller {
    private $error = array();

    public function index() {
        $this->load->language('extension/module/routee/massexport');

        $this->document->setTitle($this->language->get('heading_title'));
        $uToken = $this->session->data['user_token'];

        // Button label
        $data['button_mass'] = $this->language->get('button_mass');
        $data['product_title'] = $this->language->get('product_title');
        $data['customer_title'] = $this->language->get('customer_title');
        $data['orders_title'] = $this->language->get('orders_title');
        $data['wishlist_title'] = $this->language->get('wishlist_title');
        $data['newsletter_title'] = $this->language->get('newsletter_title');

        // Send Data to Routee
        $data['breadcrumbs'] = $this->setBreadcrumbs($uToken);

        $data['success'] = $data['error_warning'] = $data['not_exists'] = '';
        $array = array(
            'success',
            'warning',
            'not_exists'
        );
        foreach ($array as $value) {
            if (isset($this->session->data[$value])) {
                $data[$value] = $this->session->data[$value];
                unset($this->session->data[$value]);
            }
        }

        $data['uuid']   = $this->config->get('module_routee_uuid');
        $data['header'] = $this->load->controller('common/header');
        $data['footer'] = $this->load->controller('common/footer');
        $data['user_token']  = $uToken;
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['mass_export'] = $this->checkMassExport();

        $data['product_mass_url']    = $this->setMassUrl('products', $uToken);
        $data['customer_mass_url']   = $this->setMassUrl('customers', $uToken);
        $data['order_mass_url']      = $this->setMassUrl('orders', $uToken);
        $data['wishlist_mass_url']   = $this->setMassUrl('wishlist', $uToken);
        $data['newsletter_mass_url'] = $this->setMassUrl('newsletter_subscribers', $uToken);
        $data['auth_page_url']       = $this->url->link('extension/module/routee', 'user_token=' . $uToken, true);

        $this->response->setOutput($this->load->view('extension/module/routee/massexport', $data));
    }

    /**
     * @param $path
     * @param $uToken
     * @return array|string|string[]
     */
    public function setMassUrl($path, $uToken) {
        return str_replace('&amp;', '&', $this->url->link('extension/module/routee/'.$path.'/massExport', 'user_token=' . $uToken, true));
    }

    /**
     * @param $uToken
     * @return array[]
     */
    public function setBreadcrumbs($uToken) {
        return array(
            array(
                'text' => $this->language->get('text_home'),
                'href' => $this->url->link('common/dashboard', 'user_token=' . $uToken, true)
            ),
            array(
                'text' => $this->language->get('heading_title'),
                'href' => $this->url->link('extension/module/routee/massexport', 'user_token=' . $uToken, true)
            )
        );
    }

    /**
     * @return array
     */
    public function checkMassExport() {
        $this->load->model('setting/setting');
        $keys = [
            'product', 'customer', 'order', 'wishlist', 'newsletter'
        ];
        $massExport = [];
        foreach ($keys as $key) {
            $massExport[$key] = $this->model_setting_setting->getSettingValue('module_routee_'.$key.'_exported');
        }
        return $massExport;
    }
}