<?php
class ControllerExtensionModuleRouteeNewsletterSubscribers extends Controller {
    /**
     * @return void
     */
	public function massExport() {
        $this->load->library('routee');
        $action = $_POST['action'];
        $uuid = $this->config->get('module_routee_uuid');
        $this->load->language('extension/module/routee/newsletter_subscribers');
        $reload = 0;
        if (empty($uuid)) {
            $this->session->data['error_warning'] = $this->language->get('text_auth_error');
            $result = array(
                'reload' => 1
            );
        } else {
            $limit = $this->routee->getRPRLimit();
            $this->load->model('customer/customer');
            $this->load->model('setting/setting');
            $filter_data = array(
                'sort'    			=> 'name',
                'order'   			=> 'ASC',
                'filter_newsletter' => '1',
            );
            if ($action == "get_count") {
                $customerData = $this->model_customer_customer->getCustomers($filter_data);
                $t_count = count($customerData);
                if ($t_count == 0){
                    $this->session->data['not_exists'] = $this->language->get('text_not_exists');
                    $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_newsletter_exported', 1 );
                    $result = array(
                        'reload' => 1
                    );
                } else {
                    $result = array(
                        'reload' => $reload,
                        'text' => sprintf($this->language->get('text_process'), $t_count)
                    );
                }

            } elseif ( $action == "export_data" ) {
                unset($this->session->data['error_warning'] , $this->session->data['success']);
                $cycle = $_POST['cycle_count'];
                $filter_data['limit'] = $limit;
                $filter_data['start'] = ($cycle - 1) * $limit;
                $customerInfo = [];
                $customerData = $this->model_customer_customer->getCustomers($filter_data);
                $c_count = count($customerData);

                foreach($customerData as $k => $customerRow) {
                    $customerInfo[] = array('email' => $customerRow['email']);
                }
                $resultJson = $this->sendData($uuid, $customerInfo);
                if (!isset($resultJson)){
                    $this->session->data['error_warning'] = $this->language->get('text_error');
                    $reload = 1;
                } elseif (!empty($resultJson['message'])) {
                    if ($c_count < $limit){
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_newsletter_exported', 1 );
                        $this->session->data['success'] = $this->language->get('text_success');
                        $reload = 1;
                    }
                }
                $result = array(
                    'c_count' => $c_count,
                    'reload' => $reload
                );
            }
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($result));
    }

    /**
     * @param $uuid
     * @param $customerInfo
     * @return mixed|void
     */
    public function sendData($uuid, $customerInfo) {
        try {
            $this->load->library('routee');
            $this->sendLogs("Event triggered");
            $data["uuid"] = $uuid;
            $data['data'][0] = array(
                'name' => 'Newsletter Subscribers',
                'description' => 'Shop Newsletter Subscribers',
                'object' => $customerInfo,
            );
            $this->sendLogs('Before calling API');
            $result = $this->routee->curl($data, 'data');
            $this->sendLogs("After API call");
            $log = is_array($result) ? json_encode($result) : $result;
            $this->routee->write("Mass Newsletter Subscribers: ".json_encode($data)." Result: ".$log);

            return $result;
        } catch (Exception $exception) {
            $this->sendLogs($exception);
        }
    }

    /**
     * @param $message
     * @param $excep
     * @return void
     */
    public function sendLogs($message, $excep = null) {
        try {
            $this->load->library('routeelogs');
            $this->routeelogs->saveLogs('NewsletterExport','massdata', $message, $excep);
        } catch (Exception $exception) {}
    }
}