<?php
class ControllerExtensionModuleRouteeOrders extends Controller {
    /**
     * @return void
     */
	public function massExport() {
		$this->load->library('routee');
        $action = $_POST['action'];
        $uuid = $this->config->get('module_routee_uuid');
        $this->load->language('extension/module/routee/orders');
        $reload = 0;
        if (empty($uuid)) {
            $this->session->data['error_warning'] = $this->language->get('text_auth_error');
            $result = array(
                'reload' => 1
            );
        } else {
            $limit = $this->routee->getRPRLimit();
            $this->load->model('sale/order');
            $this->load->model('setting/setting');
            $filter_data = array(
                'sort'    			=> 'o.order_id',
                'order'   			=> 'DESC',
            );
            if ($action == "get_count") {
                $orderData = $this->model_sale_order->getOrders($filter_data);
                $t_count = count($orderData);
                if ($t_count == 0){
                    $this->session->data['not_exists'] = $this->language->get('text_not_exists');
                    $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_order_exported', 1 );
                    $result = array(
                        'reload' => 1
                    );
                } else {
                    $result = array(
                        'reload' => $reload,
                        'text' => sprintf($this->language->get('text_process'), $t_count)
                    );
                }

            } elseif ( $action == "export_data" ) {
                unset($this->session->data['error_warning'] , $this->session->data['success']);
                $cycle = $_POST['cycle_count'];
                $filter_data['limit'] = $limit;
                $filter_data['start'] = ($cycle - 1) * $limit;
                $orderInfo = [];
                $orderData = $this->model_sale_order->getOrders($filter_data);
                $c_count = count($orderData);

                foreach($orderData as $k => $orderRow) {
                    $order = array();
                    $order_info = $this->model_sale_order->getOrder($orderRow['order_id']);
                    if($order_info) {
                        $order['order_details'] = array('customer_id' => $order_info['customer_id'], 'order_id' => $order_info['order_id'], 'order_status' => $order_info['order_status'], 'shipping_method' => $order_info['shipping_method'], 'payment_method' => $order_info['payment_method'], 'total_price' => $order_info['total']);
                    }

                    $order_products = array();
                    $products = $this->model_sale_order->getOrderProducts($orderRow['order_id']);

                    foreach ($products as $product) {
                        $order_products[] = array(
                            'product_id' => $product['product_id'],
                            'quantity'   => $product['quantity'],
                        );
                    }

                    $order['order_products'] = $order_products;
                    $orderInfo[] = $order;
                }
                $resultJson = $this->sendData($uuid, $orderInfo);
                if (!isset($resultJson)) {
                    $this->session->data['error_warning'] = $this->language->get('text_error');
                    $reload = 1;
                } elseif (!empty($resultJson['message'])){
                    if ($c_count < $limit){
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_order_exported', 1 );
                        $this->session->data['success'] = $this->language->get('text_success');
                        $reload = 1;
                    }
                }
                $result = array(
                    'c_count' => $c_count,
                    'reload' => $reload
                );
            }
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($result));
	}

    /**
     * @param $uuid
     * @param $ordersInfo
     * @return mixed|void
     */
    public function sendData($uuid, $ordersInfo) {
        try {
            $this->load->library('routee');
            $this->sendLogs('event triggered');
            $data["uuid"] = $uuid;
            $data['data'][0] = array(
                'name' => 'Orders',
                'description' => 'Shop Orders',
                'object' => $ordersInfo,
            );
            $this->sendLogs('event before api call');
            $result = $this->routee->curl($data, 'data');
            $this->sendLogs('event after api call');
            $log = is_array($result) ? json_encode($result) : $result;
            $this->routee->write("Mass Orders: ".json_encode($data)." Result: ".$log);

            return $result;
        } catch (Exception $exception) {
            $this->sendLogs($exception->getMessage(), $exception);
        }
    }

    /**
     * @param $message
     * @param $excep
     * @return void
     */
    public function sendLogs($message, $excep=null){
        try {
            $this->load->library('routeelogs');
            $this->routeelogs->saveLogs('OrderExport','massdata', $message, $excep);
        } catch (Exception $exception){}
    }
}