<?php
class ControllerExtensionModuleRouteeWishlist extends Controller {
    /**
     * @return void
     */
	public function massExport() {
		$this->load->library('routee');
        $action = $_POST['action'];
        $uuid = $this->config->get('module_routee_uuid');
        $this->load->language('extension/module/routee/wishlist');
        $reload = 0;
        if (empty($uuid)) {
            $this->session->data['error_warning'] = $this->language->get('text_auth_error');
            $result = array(
                'reload' => 1
            );
        } else {
            $this->load->model('setting/setting');
            $limit = $this->routee->getRPRLimit();
            $this->load->model('extension/module/customer_wishlist');

            $filter_data = array(
                'sort'              => 'customer_id',
                'order'             => 'ASC'
            );
            if ($action == "get_count") {
                $customerWishlist = $this->model_extension_module_customer_wishlist->getAllWishlist();
                $t_count = count($customerWishlist);
                if ($t_count == 0){
                    $this->session->data['not_exists'] = $this->language->get('text_not_exists');
                    $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_wishlist_exported', 1 );
                    $result = array(
                        'reload' => 1
                    );
                } else {
                    $result = array(
                        'reload' => $reload,
                        'text' => sprintf($this->language->get('text_process'), $t_count)
                    );
                }
            } elseif ( $action == "export_data" ) {
                unset($this->session->data['error_warning'] , $this->session->data['success']);
                $cycle = $_POST['cycle_count'];
                $filter_data['limit'] = $limit;
                $filter_data['start'] = ($cycle - 1) * $limit;
                $wishlistInfo = [];
                $customerWishlists = $this->model_extension_module_customer_wishlist->getAllWishlistFiltered($filter_data);
                $c_count = count($customerWishlists);
                foreach($customerWishlists as $k => $customerRow) {
                    unset($customerRow['date_added']);
                    $wishlistInfo[] = $customerRow;
                }

                $resultJson = $this->sendData($uuid, $wishlistInfo);
                if (!isset($resultJson)){
                    $this->session->data['error_warning'] = $this->language->get('text_error');
                    $reload = 1;
                } elseif (!empty($resultJson['message'])){
                    if ($c_count < $limit){
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_wishlist_exported', 1 );
                        $this->session->data['success'] = $this->language->get('text_success');
                        $reload = 1;
                    }
                }
                $result = array(
                    'c_count' => $c_count,
                    'reload' => $reload
                );
            }
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($result));
    }

    /**
     * @param $uuid
     * @param $wishlistInfo
     * @return mixed|void
     */
    public function sendData($uuid, $wishlistInfo) {
        try {
            $this->load->library('routee');
            $this->sendLogs('event triggered');
            $data["uuid"] = $uuid;
            $data['data'][0] = array(
                'name' => 'Wishlist',
                'description' => 'Shop Wishlists',
                'object' => $wishlistInfo,
            );
            $this->sendLogs('event before api call');
            $result = $this->routee->curl($data, 'data');
            $this->sendLogs('event after api call');
            $log = is_array($result) ? json_encode($result) : $result;
            $this->routee->write("Mass Wishlist: ".json_encode($data)." Result: ".$log);

            return $result;
        } catch (Exception $exception) {
            $this->sendLogs($exception->getMessage(), $exception);
        }
    }

    /**
     * @param $message
     * @param $excep
     * @return void
     */
    public function sendLogs($message, $excep=null) {
        try {
            $this->load->library('routeelogs');
            $this->routeelogs->saveLogs('WishlistExport','massdata', $message, $excep);
        } catch (Exception $exception) {}
    }
}