<?php
require_once 'routeeurls.php';
/**
 * Routee class
 */
class Routee {
    private $handle;

    /**
     * Mass data export records per request limit
     */
    const RPR_LIMIT = 100;

    /**
     * Constructor
     *
     * @param string $registry
     */
    public function __construct($registry) {
        $this->handle = fopen(DIR_LOGS . 'routee.log', 'a');
        $this->registry = $registry;
    }

    /**
     *
     */
    public function __destruct() {
        fclose($this->handle);
    }

    /**
     * @param string $message
     */
    public function write($message) {
        fwrite($this->handle, date('Y-m-d G:i:s') . ' - ' . print_r($message, true) . "\n");
    }

    /**
     * @return int
     */
    public function getRPRLimit() {
        return self::RPR_LIMIT;
    }

    /**
     * @param $postData
     * @param $callFor
     * @return mixed
     */
    public function curl($postData, $callFor) {
        $dataString = json_encode($postData);
        $ch = curl_init($this->getUrl($callFor));
        if ($callFor == 'auth') {
            $dataString = htmlspecialchars_decode($dataString);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Content-Length: ' . strlen($dataString))
            );
        }
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $dataString);
        $result = curl_exec($ch);
        return json_decode($result, 1);
    }

    /**
     * @param $urlFor
     * @return string
     */
    public function getUrl($urlFor) {
        $routeeUrlObj = new RouteeUrls($this->registry);
        return $routeeUrlObj->getDynamicUrl($urlFor);
    }
}